<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>fwTrending: fwTrendingTree.ctl File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">fwTrending
   &#160;<span id="projectnumber">8.4.3</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('fwTrendingTree_8ctl.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">fwTrendingTree.ctl File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:accc22208d0f9b137f56d497c16f37d41"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#accc22208d0f9b137f56d497c16f37d41">TrendTree_navigator_selected</a> (string sNode, string sParent)</td></tr>
<tr class="separator:accc22208d0f9b137f56d497c16f37d41"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a496be630e171b37deca29a16312f7438"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a496be630e171b37deca29a16312f7438">TrendTree_editor_selected</a> (string sNode, string sParent)</td></tr>
<tr class="separator:a496be630e171b37deca29a16312f7438"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2960fb41a22247d751841aceed59734c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a2960fb41a22247d751841aceed59734c">fwTrendingTree_addToTree</a> (string sParent, string sMode, int &amp;iDone)</td></tr>
<tr class="separator:a2960fb41a22247d751841aceed59734c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1359429baa502bb3873f8d601a0144f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#af1359429baa502bb3873f8d601a0144f">fwTrendingTree_showItemInfo</a> (string sNode, string sParent)</td></tr>
<tr class="separator:af1359429baa502bb3873f8d601a0144f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a48281bbc724883da6011a7e6dda4b66b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a48281bbc724883da6011a7e6dda4b66b">TrendTree_navigator_entered</a> (string sNode, string sParent)</td></tr>
<tr class="separator:a48281bbc724883da6011a7e6dda4b66b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa42ade114d6f43adb6fc5b9e5917645c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#aa42ade114d6f43adb6fc5b9e5917645c">TrendTree_editor_entered</a> (string sNode, string sParent)</td></tr>
<tr class="separator:aa42ade114d6f43adb6fc5b9e5917645c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a113a97fa9348719c6bd3435d1b50861c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a113a97fa9348719c6bd3435d1b50861c">TrendTree_nodeView</a> (string sNode, string sParent)</td></tr>
<tr class="separator:a113a97fa9348719c6bd3435d1b50861c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1c6c4034a1e62ea6f631eb4311657a31"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a1c6c4034a1e62ea6f631eb4311657a31">TrendTree_nodeSettings</a> (string sNode, string sParent)</td></tr>
<tr class="separator:a1c6c4034a1e62ea6f631eb4311657a31"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acf6dda2dd6c2f38a7b06659e367ac3c6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#acf6dda2dd6c2f38a7b06659e367ac3c6">TrendTree_nodeParameters</a> (string sNode, string sParent)</td></tr>
<tr class="separator:acf6dda2dd6c2f38a7b06659e367ac3c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7dcc3e16dfdff0b36978b7b39e334638"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a7dcc3e16dfdff0b36978b7b39e334638">fwTrendingTree_checkIfNeedsTemplateParameters</a> (string sNode, string sDevice, string sDeviceType, bool &amp;bIsNeeded, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a7dcc3e16dfdff0b36978b7b39e334638"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a44150a01c5597ecbb1c2ccc954ed2248"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a44150a01c5597ecbb1c2ccc954ed2248">fwTrendingTree_manageTrendingDevices</a> (string sNode)</td></tr>
<tr class="separator:a44150a01c5597ecbb1c2ccc954ed2248"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d241567f74c4f127c4c8b9246332204"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a5d241567f74c4f127c4c8b9246332204">fwTrendingTree_displayNode</a> (string sNode, string sDevice, string sDeviceType, bool bEditorMode=TRUE)</td></tr>
<tr class="separator:a5d241567f74c4f127c4c8b9246332204"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae29462948f02779ee006a5caf9c7b7d2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#ae29462948f02779ee006a5caf9c7b7d2">fwTrendingTree_findInTree</a> (string sDevice, dyn_string &amp;dsParents, dyn_string &amp;dsNodes, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ae29462948f02779ee006a5caf9c7b7d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a77edfafc8f2bbc6957d6b38b87b7731c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a77edfafc8f2bbc6957d6b38b87b7731c">fwTrendingTree_showEditorPanel</a> (string sDevice, string sDeviceType, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a77edfafc8f2bbc6957d6b38b87b7731c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae378578b554e0f016a2a894f12624648"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#ae378578b554e0f016a2a894f12624648">fwTrendingTree_showNavigatorPanel</a> (string sDevice, string sDeviceType, string sTemplateParameters, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ae378578b554e0f016a2a894f12624648"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab476a665e1c98a9a56037164f8c79353"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#ab476a665e1c98a9a56037164f8c79353">_fwTrendingTree_addClipboard</a> ()</td></tr>
<tr class="separator:ab476a665e1c98a9a56037164f8c79353"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afde23f16c8ec393b3592355a97f8847f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#afde23f16c8ec393b3592355a97f8847f">_fwTrendingTree_upgradeTree</a> ()</td></tr>
<tr class="separator:afde23f16c8ec393b3592355a97f8847f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4fe1a4becb00bd221ed7d88d9647f795"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a4fe1a4becb00bd221ed7d88d9647f795">_fwTrendingTree_addSystemNameRecursive</a> (string sNode)</td></tr>
<tr class="separator:a4fe1a4becb00bd221ed7d88d9647f795"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8936a62f011109af50ade52bdd99a278"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a8936a62f011109af50ade52bdd99a278">fwTrendingTree_getTemplateParameters</a> (string sDevice, string &amp;sParameterString, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a8936a62f011109af50ade52bdd99a278"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b29afebecbe7c4825dd510342f4170f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a3b29afebecbe7c4825dd510342f4170f">TrendTree_save_as_selected</a> (string sNode, string sParent)</td></tr>
<tr class="separator:a3b29afebecbe7c4825dd510342f4170f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a375169525704b04c50c90bb76b17257b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwTrendingTree_8ctl.html#a375169525704b04c50c90bb76b17257b">TrendTree_save_as_entered</a> (string sNode, string sParent)</td></tr>
<tr class="separator:a375169525704b04c50c90bb76b17257b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This library contains the functions required by the Trending Tree</p>
<dl class="section user"><dt>Creation Date</dt><dd>04/11/04</dd></dl>
<dl class="section user"><dt>Modification History</dt><dd>None</dd></dl>
<dl class="section user"><dt>Constraints</dt><dd>Some functions rely on the fwTree and some require the Trending Editor and Navigator panel</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="section author"><dt>Author</dt><dd>Oliver Holme (IT-CO), Marco Boccioli (EN-ICE), Jonas Arroyo (EN-ICE) </dd></dl>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="accc22208d0f9b137f56d497c16f37d41"></a>
<h2 class="memtitle"><span class="permalink"><a href="#accc22208d0f9b137f56d497c16f37d41">&#9670;&nbsp;</a></span>TrendTree_navigator_selected()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TrendTree_navigator_selected </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sParent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>TrendTree_navigator_selected</p>
<p>Function that is called when the user selects an item in the Trend Tree (Navigator mode) </p><dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000006">Reviewed:</a></b></dt><dd>2018-06-22 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-Callback">Callback</a></dd></dl>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, name of the selected node </td></tr>
    <tr><td class="paramname">sParent</td><td>input, name of the parent of the selected node </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a496be630e171b37deca29a16312f7438"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a496be630e171b37deca29a16312f7438">&#9670;&nbsp;</a></span>TrendTree_editor_selected()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TrendTree_editor_selected </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sParent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>TrendTree_editor_selected Function that is called when the user selects an item in the Trend Tree (Editor mode) </p><dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000007">Reviewed:</a></b></dt><dd>2018-06-22 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-Callback">Callback</a></dd></dl>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, name of the selected node </td></tr>
    <tr><td class="paramname">sParent</td><td>input, name of the parent of the selected node </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a2960fb41a22247d751841aceed59734c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2960fb41a22247d751841aceed59734c">&#9670;&nbsp;</a></span>fwTrendingTree_addToTree()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwTrendingTree_addToTree </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sParent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sMode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>iDone</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function that is called when the user chooses to Add an item in the Trend Tree (Editor mode)</p>
<p>Adapted from generic function in fwTreeDisplay.ctl</p>
<dl class="section user"><dt>Constraints</dt><dd>Uses global variables: FwTreeTypes[], FwTreeNames[], FwActiveTrees[] and CurrTreeIndex</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sParent</td><td>input, name of the parent of the node to be created </td></tr>
    <tr><td class="paramname">sMode</td><td>input, the type of addition. Can be one of:<ul>
<li>"addnode" Add an emtpy node to the tree</li>
<li>"addnew" Create a new device (plot or page) and create a new node to add it in the tree</li>
<li>"addexisting" Create a new node to link to an existing device (plot or page) </li>
</ul>
</td></tr>
    <tr><td class="paramname">iDone</td><td>output, value is 1 if the node was created, 0 if the process was stopped before creation </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="af1359429baa502bb3873f8d601a0144f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af1359429baa502bb3873f8d601a0144f">&#9670;&nbsp;</a></span>fwTrendingTree_showItemInfo()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwTrendingTree_showItemInfo </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sParent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function that displays the information about the currently selected node in the Trending Editor &amp; Navigator</p>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, name of the selected node </td></tr>
    <tr><td class="paramname">sParent</td><td>input, name of the parent of the selected node </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a48281bbc724883da6011a7e6dda4b66b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a48281bbc724883da6011a7e6dda4b66b">&#9670;&nbsp;</a></span>TrendTree_navigator_entered()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TrendTree_navigator_entered </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sParent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>TrendTree_navigator_entered Function that is called when the user right-clicks an item in the Trend Tree (Navigator mode) It displays a contextual menu with the ncessary options for the selected device in the current mode.</p>
<p>Adapted from generic function in fwTreeDisplay.ctl </p><dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000008">Reviewed:</a></b></dt><dd>2018-06-22 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-Callback">Callback</a></dd></dl>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, name of the selected node </td></tr>
    <tr><td class="paramname">sParent</td><td>input, name of the parent of the selected node </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aa42ade114d6f43adb6fc5b9e5917645c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa42ade114d6f43adb6fc5b9e5917645c">&#9670;&nbsp;</a></span>TrendTree_editor_entered()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TrendTree_editor_entered </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sParent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>TrendTree_editor_entered Function that is called when the user right-clicks an item in the Trend Tree (Editor mode) It displays a contextual menu with the ncessary options for the selected device in the current mode.</p>
<p>Adapted from generic function in fwTreeDisplay.ctl </p><dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000009">Reviewed:</a></b></dt><dd>2018-06-22 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-Callback">Callback</a></dd></dl>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, name of the selected node </td></tr>
    <tr><td class="paramname">sParent</td><td>input, name of the parent of the selected node </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a113a97fa9348719c6bd3435d1b50861c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a113a97fa9348719c6bd3435d1b50861c">&#9670;&nbsp;</a></span>TrendTree_nodeView()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TrendTree_nodeView </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sParent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function that is called when the user selects View from the contextual menu in the Trend Tree (Navigator mode)</p>
<p>Adapted from generic function in fwTreeDisplay.ctl</p>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, name of the selected node </td></tr>
    <tr><td class="paramname">sParent</td><td>input, name of the parent of the selected node </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a1c6c4034a1e62ea6f631eb4311657a31"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1c6c4034a1e62ea6f631eb4311657a31">&#9670;&nbsp;</a></span>TrendTree_nodeSettings()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TrendTree_nodeSettings </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sParent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>TrendTree_nodeSettings Function that is called when the user selects Settings from the contextual menu in the Trend Tree (Editor mode)</p>
<p>Adapted from generic function in fwTreeDisplay.ctl </p><dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000010">Reviewed:</a></b></dt><dd>2018-06-22 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-Callback">Callback</a></dd></dl>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, name of the selected node </td></tr>
    <tr><td class="paramname">sParent</td><td>input, name of the parent of the selected node </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="acf6dda2dd6c2f38a7b06659e367ac3c6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acf6dda2dd6c2f38a7b06659e367ac3c6">&#9670;&nbsp;</a></span>TrendTree_nodeParameters()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TrendTree_nodeParameters </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sParent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>TrendTree_nodeParameters Function that is called when the user selects Template Parameters from the contextual menu in the Trend Tree (Editor mode) Reads any existing settings from the node user data and then lets the user modify the values for any required parameters. This modified value is then saved back to the user data. </p><dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000011">Reviewed:</a></b></dt><dd>2018-06-22 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-Callback">Callback</a></dd></dl>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, name of the selected node </td></tr>
    <tr><td class="paramname">sParent</td><td>input, name of the parent of the selected node </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a7dcc3e16dfdff0b36978b7b39e334638"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7dcc3e16dfdff0b36978b7b39e334638">&#9670;&nbsp;</a></span>fwTrendingTree_checkIfNeedsTemplateParameters()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwTrendingTree_checkIfNeedsTemplateParameters </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDeviceType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool &amp;&#160;</td>
          <td class="paramname"><em>bIsNeeded</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Checks if any template parameters are mentioned in the configuration for the given node/device in the tree.</p>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, name of the selected node </td></tr>
    <tr><td class="paramname">sDevice</td><td>input, name of the device attached to the node </td></tr>
    <tr><td class="paramname">sDeviceType</td><td>input, dp type of the device attached to the node </td></tr>
    <tr><td class="paramname">bIsNeeded</td><td>output, TRUE if any template parameters are mentioned in configuration, else FALSE </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>Any exceptions are returned here </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a44150a01c5597ecbb1c2ccc954ed2248"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a44150a01c5597ecbb1c2ccc954ed2248">&#9670;&nbsp;</a></span>fwTrendingTree_manageTrendingDevices()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwTrendingTree_manageTrendingDevices </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function that is called when the user selects "Manage Plots and Pages..." from the contextual menu in the Trend Tree (Editor mode)</p>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, used to determine the panel title and also passed as $ parameter to panel (but this is not used by the panel) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a5d241567f74c4f127c4c8b9246332204"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5d241567f74c4f127c4c8b9246332204">&#9670;&nbsp;</a></span>fwTrendingTree_displayNode()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwTrendingTree_displayNode </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDeviceType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>bEditorMode</em> = <code>TRUE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function that is used to show either the editor or navigator panel for a specific tree node</p>
<dl class="section user"><dt>Constraints</dt><dd>Only works for devices other than tree nodes (i.e. TrendingPages or TrendingPlots)</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, the currently selected node in the tree </td></tr>
    <tr><td class="paramname">sDevice</td><td>input, the name of the device attached to the selected node </td></tr>
    <tr><td class="paramname">sDeviceType</td><td>input, the dpType of the device attached to the selected node </td></tr>
    <tr><td class="paramname">bEditorMode</td><td>Optional parameter, default value TRUE. TRUE to display editor panel, FALSE to show navigator panel. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ae29462948f02779ee006a5caf9c7b7d2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae29462948f02779ee006a5caf9c7b7d2">&#9670;&nbsp;</a></span>fwTrendingTree_findInTree()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwTrendingTree_findInTree </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>dsParents</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>dsNodes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Finds all the occurences of a given device tree</p>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDevice</td><td>input, the device to search for </td></tr>
    <tr><td class="paramname">sParents</td><td>input, a list of parents of the nodes to which the device is attached </td></tr>
    <tr><td class="paramname">sNodes</td><td>input, a list of the nodes to which the device is attached </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>Any exceptions are returned here </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a77edfafc8f2bbc6957d6b38b87b7731c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a77edfafc8f2bbc6957d6b38b87b7731c">&#9670;&nbsp;</a></span>fwTrendingTree_showEditorPanel()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwTrendingTree_showEditorPanel </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDeviceType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Shows the editor panel for the given device (panel to be shown is read from device definitions)</p>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDevice</td><td>input, the device to open the panel for </td></tr>
    <tr><td class="paramname">sDeviceType</td><td>input, the dpType of the device </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>Any exceptions are returned here </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ae378578b554e0f016a2a894f12624648"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae378578b554e0f016a2a894f12624648">&#9670;&nbsp;</a></span>fwTrendingTree_showNavigatorPanel()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwTrendingTree_showNavigatorPanel </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDeviceType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sTemplateParameters</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Shows the navigator panel for the given device (panel to be shown is read from device definitions)</p>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDevice</td><td>input, the device to open the panel for </td></tr>
    <tr><td class="paramname">sDeviceType</td><td>input, the dpType of the device </td></tr>
    <tr><td class="paramname">sTemplateParameters</td><td>input, any template parameters for the device are passed here </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>Any exceptions are returned here </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ab476a665e1c98a9a56037164f8c79353"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab476a665e1c98a9a56037164f8c79353">&#9670;&nbsp;</a></span>_fwTrendingTree_addClipboard()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void _fwTrendingTree_addClipboard </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Adds a clipboard to the Trend Tree</p>
<dl class="section user"><dt>Constraints</dt><dd>Only needs to be run once</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION </dd></dl>

</div>
</div>
<a id="afde23f16c8ec393b3592355a97f8847f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afde23f16c8ec393b3592355a97f8847f">&#9670;&nbsp;</a></span>_fwTrendingTree_upgradeTree()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void _fwTrendingTree_upgradeTree </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Upgrades old trees to the new format of tree (new format as of fwTrending2.3)</p>
<dl class="section user"><dt>Constraints</dt><dd>Should only be run once</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION </dd></dl>

</div>
</div>
<a id="a4fe1a4becb00bd221ed7d88d9647f795"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4fe1a4becb00bd221ed7d88d9647f795">&#9670;&nbsp;</a></span>_fwTrendingTree_addSystemNameRecursive()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void _fwTrendingTree_addSystemNameRecursive </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Goes through old trees and adds the system name to any device references that do not contain the system name</p>
<dl class="section user"><dt>Constraints</dt><dd>If not system name is specified, it is assumed that the device is on the local system</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">node</td><td>Used to recursively work through the tree. Give the name of the top node of the tree </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a8936a62f011109af50ade52bdd99a278"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8936a62f011109af50ade52bdd99a278">&#9670;&nbsp;</a></span>fwTrendingTree_getTemplateParameters()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwTrendingTree_getTemplateParameters </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>sParameterString</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>For a given device connected to a tree node, this function will check if any template parameters are required. If so, a dialog is shown and the user can enter values for the template parameters (or choose not to). This string is then returned by the function, and the value should then be stored in the userData of the relevant data.</p>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">device</td><td>input, the device to look at for template parameters </td></tr>
    <tr><td class="paramname">parameterString</td><td>output, any template parameters that were configured by the user are returned here </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>Any exceptions are returned here </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a3b29afebecbe7c4825dd510342f4170f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3b29afebecbe7c4825dd510342f4170f">&#9670;&nbsp;</a></span>TrendTree_save_as_selected()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TrendTree_save_as_selected </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sParent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>TrendTree_save_as_selected Function that is called when the user clicks on an item in the Trend Tree (save_as mode) It will check if node tree selected is a Trending node (neither Plot or Page), and will selected it. </p><dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000012">Reviewed:</a></b></dt><dd>2018-06-22 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-Callback">Callback</a></dd></dl>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, name of the selected node </td></tr>
    <tr><td class="paramname">sParent</td><td>input, name of the parent of the selected node </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a375169525704b04c50c90bb76b17257b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a375169525704b04c50c90bb76b17257b">&#9670;&nbsp;</a></span>TrendTree_save_as_entered()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TrendTree_save_as_entered </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sParent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>TrendTree_save_as_entered Function that is called when the user right-clicks an item in the Trend Tree (save_as mode) It displays a contextual menu with the ncessary options for the selected device in the current mode. </p><dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000013">Reviewed:</a></b></dt><dd>2018-06-22 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-Callback">Callback</a></dd></dl>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Internal</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sNode</td><td>input, name of the selected node </td></tr>
    <tr><td class="paramname">sParent</td><td>input, name of the parent of the selected node </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="fwTrendingTree_8ctl.html">fwTrendingTree.ctl</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
